module fsm_rd_003_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [3:0] ptext;
	output[3:0] rtext;
	reg [3:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_003_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1_n;
		rtext <= 'bx110;
	  end
	  st_st1_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b1xx0;
	  end
	  st_st2: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st2_n;
		rtext <= 'b1xx0;
	  end
	  st_st2_n: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b0x1x;
	  end
	  st_st3: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b1101;
	  end
	  st_st4: begin
		if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4_n;
		rtext <= 'b1101;
	  end
	  st_st4_n: begin
		if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b1010;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5_n;
		rtext <= 'b1010;
	  end
	  st_st5_n: begin
		if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b0x10;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b00x1;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st8;
		rtext <= 'b0000;
	  end
	  st_st8: begin
		if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st8_n;
		rtext <= 'b0000;
	  end
	  st_st8_n: begin
		if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b0110;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
