module fsm_rd_039_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [3:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_039_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b0x0001x10111;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b1110010010x0;
	  end
	  st_st2: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st2_n;
		rtext <= 'b1110010010x0;
	  end
	  st_st2_n: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b001111101100;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b10x11101xx11;
	  end
	  st_st4: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b10110x111111;
	  end
	  st_st5: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b10110x111111;
	  end
	  st_st5_n: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b1111111001x1;
	  end
	  st_st6: begin
		if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st7;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b01111x000x11;
	  end
	  st_st7: begin
		if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st7_n;
		rtext <= 'b01111x000x11;
	  end
	  st_st7_n: begin
		if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b011x1x000110;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
