module fsm_rd_048_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [3:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_048_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b101111011111;
	  end
	  st_st2: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0 )
 		  NextState <= st_st2_n;
		rtext <= 'b101111011111;
	  end
	  st_st2_n: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0 )
 		  NextState <= st_st2;
		rtext <= 'b101010000000;
	  end
	  st_st3: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3_n;
		rtext <= 'b101010000000;
	  end
	  st_st3_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b101011011000;
	  end
	  st_st4: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b101001001001;
	  end
	  st_st5: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b101001001001;
	  end
	  st_st5_n: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b001101010001;
	  end
	  st_st6: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b001101010001;
	  end
	  st_st6_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b111010110100;
	  end
	  st_st7: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1 )
 		  NextState <= st_st7_n;
		rtext <= 'b111010110100;
	  end
	  st_st7_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b101011101001;
	  end
	  st_st8: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b110011111000;
	  end
	  st_st9: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b110011111000;
	  end
	  st_st9_n: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b000111101110;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b110101111011;
	  end
	  st_st11: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[3] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st11_n;
		rtext <= 'b110101111011;
	  end
	  st_st11_n: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[3] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b100010111111;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b110100011101;
	  end
	  st_st13: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0 )
 		  NextState <= st_st13_n;
		rtext <= 'b110100011101;
	  end
	  st_st13_n: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b110100011101;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
