module fsm_rd_049_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[2:0] rtext;
	reg [2:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_049_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b000;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b001;
	  end
	  st_st2: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1 )
 		  NextState <= st_st2_n;
		rtext <= 'b001;
	  end
	  st_st2_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b100;
	  end
	  st_st3: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b010;
	  end
	  st_st4: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b010;
	  end
	  st_st5: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0 )
 		  NextState <= st_st5_n;
		rtext <= 'b010;
	  end
	  st_st5_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
