module fsm_rd_061_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[1:0] rtext;
	reg [1:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_061_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st1_n;
		rtext <= 'b01;
	  end
	  st_st1_n: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b00;
	  end
	  st_st2: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b10;
	  end
	  st_st3: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b11;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b11;
	  end
	  st_st4_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b10;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b01;
	  end
	  st_st6: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01;
	  end
	  st_st7: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b01;
	  end
	  st_st7_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b10;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8_n;
		rtext <= 'b10;
	  end
	  st_st8_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b10;
	  end
	  st_st9: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1 )
 		  NextState <= st_st10;
		rtext <= 'b10;
	  end
	  st_st10: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0 )
 		  NextState <= st_st10_n;
		rtext <= 'b10;
	  end
	  st_st10_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b10;
	  end
	  st_st11: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b10;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st19;
		rtext <= 'b10;
	  end
	  st_st13: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b01;
	  end
	  st_st14: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b10;
	  end
	  st_st15: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0 )
 		  NextState <= st_st15_n;
		rtext <= 'b10;
	  end
	  st_st15_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b10;
	  end
	  st_st16: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b10;
	  end
	  st_st17: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17_n;
		rtext <= 'b10;
	  end
	  st_st17_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b11;
	  end
	  st_st18: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b01;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st12;
		rtext <= 'b10;
	  end
	  st_st20: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b10;
	  end
	  st_st21: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b00;
	  end
	  st_st22: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0 )
 		  NextState <= st_st22_n;
		rtext <= 'b00;
	  end
	  st_st22_n: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b10;
	  end
	  st_st23: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b00;
	  end
	  st_st24: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b11;
	  end
	  st_st25: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1 )
 		  NextState <= st_st25_n;
		rtext <= 'b11;
	  end
	  st_st25_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b01;
	  end
	  st_st26: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1 )
 		  NextState <= st_st27;
		rtext <= 'b01;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st28;
		rtext <= 'b00;
	  end
	  st_st28: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st28_n;
		rtext <= 'b00;
	  end
	  st_st28_n: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b10;
	  end
	  st_st29: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1 )
 		  NextState <= st_st29_n;
		rtext <= 'b10;
	  end
	  st_st29_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b00;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b10;
	  end
	  st_st31: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1 )
 		  NextState <= st_st31_n;
		rtext <= 'b10;
	  end
	  st_st31_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b10;
	  end
	  st_st32: begin
		if(1)
 		  NextState <= st_st33;
		rtext <= 'b10;
	  end
	  st_st33: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0 )
 		  NextState <= st_st20;
		rtext <= 'b10;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
