module fsm_rd_065_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[4:0] rtext;
	reg [4:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_065_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b00100;
	  end
	  st_st2: begin
		if(1)
 		  NextState <= st_st3;
		rtext <= 'b11101;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b11111;
	  end
	  st_st4: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0 )
 		  NextState <= st_st4_n;
		rtext <= 'b11111;
	  end
	  st_st4_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b01000;
	  end
	  st_st5: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b01000;
	  end
	  st_st5_n: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b11011;
	  end
	  st_st6: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b00011;
	  end
	  st_st7: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b10011;
	  end
	  st_st8: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b00111;
	  end
	  st_st9: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st9_n;
		rtext <= 'b00111;
	  end
	  st_st9_n: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b01100;
	  end
	  st_st10: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0 )
 		  NextState <= st_st10_n;
		rtext <= 'b01100;
	  end
	  st_st10_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b10111;
	  end
	  st_st11: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b01011;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b10101;
	  end
	  st_st13: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st13_n;
		rtext <= 'b10101;
	  end
	  st_st13_n: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b11001;
	  end
	  st_st14: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1 )
 		  NextState <= st_st14_n;
		rtext <= 'b11001;
	  end
	  st_st14_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b11001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
