module fsm_rd_068_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [11:0] ptext;
	output[4:0] rtext;
	reg [4:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_068_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[1] == 0  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[11] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b10001;
	  end
	  st_st2: begin
		if(ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b10001;
	  end
	  st_st2_n: begin
		if(ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b01110;
	  end
	  st_st3: begin
		if(ptext[11] == 0 )
 		  NextState <= st_st4;
		else if(ptext[11] == 1 )
 		  NextState <= st_st3_n;
		rtext <= 'b01110;
	  end
	  st_st3_n: begin
		if(ptext[11] == 0 )
 		  NextState <= st_st4;
		else if(ptext[11] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b1000x;
	  end
	  st_st4: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[5] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00000;
	  end
	  st_st5: begin
		if(ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[11] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b00000;
	  end
	  st_st5_n: begin
		if(ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[11] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00011;
	  end
	  st_st6: begin
		if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6_n;
		rtext <= 'b00011;
	  end
	  st_st6_n: begin
		if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b1100x;
	  end
	  st_st7: begin
		if(ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[10] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b11011;
	  end
	  st_st8: begin
		if(ptext[9] == 1 )
 		  NextState <= st_st7;
		else if(ptext[9] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b10011;
	  end
	  st_st9: begin
		if(ptext[4] == 0  && ptext[11] == 0 )
 		  NextState <= st_st8;
		else if(ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[4] == 1  && ptext[11] == 0 )
 		  NextState <= st_st9_n;
		rtext <= 'b10011;
	  end
	  st_st9_n: begin
		if(ptext[4] == 0  && ptext[11] == 0 )
 		  NextState <= st_st8;
		else if(ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[4] == 1  && ptext[11] == 0 )
 		  NextState <= st_st9;
		rtext <= 'bx1x10;
	  end
	  st_st10: begin
		if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10_n;
		rtext <= 'bx1x10;
	  end
	  st_st10_n: begin
		if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10;
		rtext <= 'b00000;
	  end
	  st_st11: begin
		if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11_n;
		rtext <= 'b00000;
	  end
	  st_st11_n: begin
		if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b01010;
	  end
	  st_st12: begin
		if(ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[9] == 0 )
 		  NextState <= st_st12_n;
		rtext <= 'b01010;
	  end
	  st_st12_n: begin
		if(ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[9] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b00011;
	  end
	  st_st13: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b01010;
	  end
	  st_st14: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[4] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b10001;
	  end
	  st_st15: begin
		if(ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[8] == 0 )
 		  NextState <= st_st15_n;
		rtext <= 'b10001;
	  end
	  st_st15_n: begin
		if(ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[8] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b01010;
	  end
	  st_st16: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b00000;
	  end
	  st_st17: begin
		if(ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[4] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b01x01;
	  end
	  st_st18: begin
		if(ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18_n;
		rtext <= 'b01x01;
	  end
	  st_st18_n: begin
		if(ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b001x1;
	  end
	  st_st19: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st18;
		else if(ptext[3] == 1 )
 		  NextState <= st_st20;
		rtext <= 'bx1001;
	  end
	  st_st20: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[6] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b01001;
	  end
	  st_st21: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21_n;
		rtext <= 'b01001;
	  end
	  st_st21_n: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b01x01;
	  end
	  st_st22: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0 )
 		  NextState <= st_st22_n;
		rtext <= 'b01x01;
	  end
	  st_st22_n: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b00011;
	  end
	  st_st23: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0 )
 		  NextState <= st_st24;
		rtext <= 'b01011;
	  end
	  st_st24: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st25;
		else if(ptext[5] == 1 )
 		  NextState <= st_st24_n;
		rtext <= 'b01011;
	  end
	  st_st24_n: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st25;
		else if(ptext[5] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b00000;
	  end
	  st_st25: begin
		if(ptext[0] == 0  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[7] == 1 )
 		  NextState <= st_st25_n;
		rtext <= 'b00000;
	  end
	  st_st25_n: begin
		if(ptext[0] == 0  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[7] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b1x0xx;
	  end
	  st_st26: begin
		if(ptext[9] == 0 )
 		  NextState <= st_st25;
		else if(ptext[9] == 1 )
 		  NextState <= st_st27;
		rtext <= 'bxxx11;
	  end
	  st_st27: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b00x01;
	  end
	  st_st28: begin
		if(ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[5] == 1  && ptext[10] == 0 )
 		  NextState <= st_st28_n;
		rtext <= 'b00x01;
	  end
	  st_st28_n: begin
		if(ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[5] == 1  && ptext[10] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b11011;
	  end
	  st_st29: begin
		if(ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st28;
		else if(ptext[2] == 0 )
 		  NextState <= st_st30;
		else if(ptext[2] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29_n;
		rtext <= 'b11011;
	  end
	  st_st29_n: begin
		if(ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st28;
		else if(ptext[2] == 0 )
 		  NextState <= st_st30;
		else if(ptext[2] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b01110;
	  end
	  st_st30: begin
		if(ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st29;
		else if(ptext[11] == 0 )
 		  NextState <= st_st31;
		else if(ptext[6] == 0  && ptext[11] == 1 )
 		  NextState <= st_st30_n;
		rtext <= 'b01110;
	  end
	  st_st30_n: begin
		if(ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st29;
		else if(ptext[11] == 0 )
 		  NextState <= st_st31;
		else if(ptext[6] == 0  && ptext[11] == 1 )
 		  NextState <= st_st30;
		rtext <= 'b11000;
	  end
	  st_st31: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0 )
 		  NextState <= st_st31_n;
		rtext <= 'b11000;
	  end
	  st_st31_n: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b00x0x;
	  end
	  st_st32: begin
		if(ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[7] == 0 )
 		  NextState <= st_st32_n;
		rtext <= 'b00x0x;
	  end
	  st_st32_n: begin
		if(ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[7] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b0x100;
	  end
	  st_st33: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[3] == 1 )
 		  NextState <= st_st34;
		rtext <= 'bx1001;
	  end
	  st_st34: begin
		if(ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[4] == 1 )
 		  NextState <= st_st34_n;
		rtext <= 'bx1001;
	  end
	  st_st34_n: begin
		if(ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[4] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b11101;
	  end
	  st_st35: begin
		if(ptext[11] == 1 )
 		  NextState <= st_st34;
		else if(ptext[11] == 0 )
 		  NextState <= st_st36;
		rtext <= 'bxx001;
	  end
	  st_st36: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0 )
 		  NextState <= st_st37;
		rtext <= 'b10101;
	  end
	  st_st37: begin
		if(ptext[7] == 1  && ptext[11] == 0 )
 		  NextState <= st_st36;
		else if(ptext[11] == 1 )
 		  NextState <= st_st38;
		else if(ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st37_n;
		rtext <= 'b10101;
	  end
	  st_st37_n: begin
		if(ptext[7] == 1  && ptext[11] == 0 )
 		  NextState <= st_st36;
		else if(ptext[11] == 1 )
 		  NextState <= st_st38;
		else if(ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st37;
		rtext <= 'bx101x;
	  end
	  st_st38: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st37;
		else if(ptext[4] == 0 )
 		  NextState <= st_st39;
		rtext <= 'b01010;
	  end
	  st_st39: begin
		if(ptext[5] == 1 )
 		  NextState <= st_st38;
		else if(ptext[5] == 0 )
 		  NextState <= st_st40;
		rtext <= 'b1x0x1;
	  end
	  st_st40: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st41;
		else if(ptext[10] == 0 )
 		  NextState <= st_st40_n;
		rtext <= 'b1x0x1;
	  end
	  st_st40_n: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st41;
		else if(ptext[10] == 0 )
 		  NextState <= st_st40;
		rtext <= 'bx1001;
	  end
	  st_st41: begin
		if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st41_n;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st42;
		rtext <= 'bx1001;
	  end
	  st_st41_n: begin
		if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b0011x;
	  end
	  st_st42: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[4] == 0 )
 		  NextState <= st_st43;
		rtext <= 'bx0010;
	  end
	  st_st43: begin
		if(ptext[4] == 0 )
 		  NextState <= st_st42;
		else if(ptext[4] == 1 )
 		  NextState <= st_st44;
		rtext <= 'b0110x;
	  end
	  st_st44: begin
		if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st43;
		else if(ptext[5] == 0 )
 		  NextState <= st_st45;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st44_n;
		rtext <= 'b0110x;
	  end
	  st_st44_n: begin
		if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st43;
		else if(ptext[5] == 0 )
 		  NextState <= st_st45;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st44;
		rtext <= 'b000x1;
	  end
	  st_st45: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st44;
		else if(ptext[4] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b0x010;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
