module fsm_rd_069_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [11:0] ptext;
	output[4:0] rtext;
	reg [4:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_069_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[1] == 0  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st1_n;
		rtext <= 'b10x10;
	  end
	  st_st1_n: begin
		if(ptext[1] == 0  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b10101;
	  end
	  st_st2: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b01011;
	  end
	  st_st3: begin
		if(ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[5] == 0 )
 		  NextState <= st_st3_n;
		rtext <= 'b01011;
	  end
	  st_st3_n: begin
		if(ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[5] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b00001;
	  end
	  st_st4: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b00001;
	  end
	  st_st4_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b11x00;
	  end
	  st_st5: begin
		if(ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st4;
		else if(ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st46;
		else if(ptext[7] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b11x00;
	  end
	  st_st5_n: begin
		if(ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st4;
		else if(ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st5;
		else if(ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st46;
		else if(ptext[7] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b0x101;
	  end
	  st_st6: begin
		if(ptext[11] == 1 )
 		  NextState <= st_st5;
		else if(ptext[11] == 0 )
 		  NextState <= st_st7;
		rtext <= 'bx1010;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st8;
		rtext <= 'bx0100;
	  end
	  st_st8: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[5] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b11100;
	  end
	  st_st9: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b10x00;
	  end
	  st_st10: begin
		if(ptext[0] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[8] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[8] == 0 )
 		  NextState <= st_st10_n;
		else if(ptext[0] == 1  && ptext[8] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b10x00;
	  end
	  st_st10_n: begin
		if(ptext[0] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[8] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[8] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b01010;
	  end
	  st_st11: begin
		if(1)
 		  NextState <= st_st12;
		rtext <= 'b0x011;
	  end
	  st_st12: begin
		if(ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[6] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b0010x;
	  end
	  st_st13: begin
		if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13_n;
		rtext <= 'b0010x;
	  end
	  st_st13_n: begin
		if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b10000;
	  end
	  st_st14: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b01010;
	  end
	  st_st15: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b01000;
	  end
	  st_st16: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[5] == 1 )
 		  NextState <= st_st16_n;
		rtext <= 'b01000;
	  end
	  st_st16_n: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[5] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b01000;
	  end
	  st_st17: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[4] == 0 )
 		  NextState <= st_st17_n;
		rtext <= 'b01000;
	  end
	  st_st17_n: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[4] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b00110;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st19;
		rtext <= 'b1101x;
	  end
	  st_st19: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[9] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[9] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st19_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[9] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b1101x;
	  end
	  st_st19_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[9] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[9] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[9] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		rtext <= 'bx0000;
	  end
	  st_st20: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[6] == 1 )
 		  NextState <= st_st20_n;
		rtext <= 'bx0000;
	  end
	  st_st20_n: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[6] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b01100;
	  end
	  st_st21: begin
		if(1)
 		  NextState <= st_st22;
		rtext <= 'b1x101;
	  end
	  st_st22: begin
		if(ptext[8] == 0 )
 		  NextState <= st_st23;
		else if(ptext[8] == 1 )
 		  NextState <= st_st22_n;
		rtext <= 'b1x101;
	  end
	  st_st22_n: begin
		if(ptext[8] == 0 )
 		  NextState <= st_st23;
		else if(ptext[8] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b1x011;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'bx00x1;
	  end
	  st_st24: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b00010;
	  end
	  st_st25: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1 )
 		  NextState <= st_st25_n;
		rtext <= 'b00010;
	  end
	  st_st25_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b1001x;
	  end
	  st_st26: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0 )
 		  NextState <= st_st26_n;
		rtext <= 'b1001x;
	  end
	  st_st26_n: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0 )
 		  NextState <= st_st26;
		rtext <= 'b10101;
	  end
	  st_st27: begin
		if(ptext[4] == 0  && ptext[11] == 0 )
 		  NextState <= st_st26;
		else if(ptext[11] == 1 )
 		  NextState <= st_st28;
		else if(ptext[4] == 1  && ptext[11] == 0 )
 		  NextState <= st_st27_n;
		rtext <= 'b10101;
	  end
	  st_st27_n: begin
		if(ptext[4] == 0  && ptext[11] == 0 )
 		  NextState <= st_st26;
		else if(ptext[11] == 1 )
 		  NextState <= st_st28;
		else if(ptext[4] == 1  && ptext[11] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b1xx1x;
	  end
	  st_st28: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st27;
		else if(ptext[3] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b0010x;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st30;
		rtext <= 'b100xx;
	  end
	  st_st30: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b00100;
	  end
	  st_st31: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st30;
		else if(ptext[10] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b11110;
	  end
	  st_st32: begin
		if(ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st31;
		else if(ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st33;
		else if(ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st33;
		rtext <= 'b11110;
	  end
	  st_st32_n: begin
		if(ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st31;
		else if(ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st33;
		else if(ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st33;
		rtext <= 'b10101;
	  end
	  st_st33: begin
		if(1)
 		  NextState <= st_st34;
		rtext <= 'b11011;
	  end
	  st_st34: begin
		if(ptext[7] == 1 )
 		  NextState <= st_st33;
		else if(ptext[7] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b0x000;
	  end
	  st_st35: begin
		if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st34;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st35_n;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st36;
		rtext <= 'b0x000;
	  end
	  st_st35_n: begin
		if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st34;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st35;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st36;
		rtext <= 'b10010;
	  end
	  st_st36: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st35;
		else if(ptext[2] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b10010;
	  end
	  st_st37: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0 )
 		  NextState <= st_st38;
		rtext <= 'b00x10;
	  end
	  st_st38: begin
		if(ptext[11] == 1 )
 		  NextState <= st_st39;
		else if(ptext[11] == 0 )
 		  NextState <= st_st38_n;
		rtext <= 'b00x10;
	  end
	  st_st38_n: begin
		if(ptext[11] == 1 )
 		  NextState <= st_st39;
		else if(ptext[11] == 0 )
 		  NextState <= st_st38;
		rtext <= 'b10x00;
	  end
	  st_st39: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st40;
		else if(ptext[10] == 0 )
 		  NextState <= st_st39_n;
		rtext <= 'b10x00;
	  end
	  st_st39_n: begin
		if(ptext[10] == 1 )
 		  NextState <= st_st40;
		else if(ptext[10] == 0 )
 		  NextState <= st_st39;
		rtext <= 'b10100;
	  end
	  st_st40: begin
		if(1)
 		  NextState <= st_st41;
		rtext <= 'b01010;
	  end
	  st_st41: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b00011;
	  end
	  st_st42: begin
		if(ptext[10] == 0 )
 		  NextState <= st_st43;
		else if(ptext[10] == 1 )
 		  NextState <= st_st42_n;
		rtext <= 'b00011;
	  end
	  st_st42_n: begin
		if(ptext[10] == 0 )
 		  NextState <= st_st43;
		else if(ptext[10] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b0xx10;
	  end
	  st_st43: begin
		if(1)
 		  NextState <= st_st44;
		rtext <= 'b0001x;
	  end
	  st_st44: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st45;
		else if(ptext[3] == 1 )
 		  NextState <= st_st44_n;
		rtext <= 'b0001x;
	  end
	  st_st44_n: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st45;
		else if(ptext[3] == 1 )
 		  NextState <= st_st44;
		rtext <= 'b11010;
	  end
	  st_st45: begin
		if(1)
 		  NextState <= st_st46;
		rtext <= 'b00000;
	  end
	  st_st46: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b00000;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
