module fsm_rd_071_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [3:0] ptext;
	output[15:0] rtext;
	reg [15:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_071_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1_n;
		rtext <= 'b0000000000000000;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b0101100111011110;
	  end
	  st_st2: begin
		if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b0101100111011110;
	  end
	  st_st2_n: begin
		if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b0100000100000100;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b0101000111000100;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b0101000111000100;
	  end
	  st_st4_n: begin
		if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b0100010100000101;
	  end
	  st_st5: begin
		if(1)
 		  NextState <= st_st6;
		rtext <= 'b1111111111111111;
	  end
	  st_st6: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b0101110111011111;
	  end
	  st_st7: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0 )
 		  NextState <= st_st7_n;
		rtext <= 'b0101110111011111;
	  end
	  st_st7_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b0001100111000100;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b0001100111000100;
	  end
	  st_st8_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b0001110111000101;
	  end
	  st_st9: begin
		if(1)
 		  NextState <= st_st10;
		rtext <= 'b0100110100011111;
	  end
	  st_st10: begin
		if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10_n;
		rtext <= 'b0100110100011111;
	  end
	  st_st10_n: begin
		if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b1011100111100101;
	  end
	  st_st11: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0 )
 		  NextState <= st_st11_n;
		rtext <= 'b1011100111100101;
	  end
	  st_st11_n: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b1010000011000001;
	  end
	  st_st12: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b1010000011000001;
	  end
	  st_st12_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b0101010111000101;
	  end
	  st_st13: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b0000010000000001;
	  end
	  st_st14: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b0011100111100100;
	  end
	  st_st15: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0 )
 		  NextState <= st_st15_n;
		rtext <= 'b0011100111100100;
	  end
	  st_st15_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b1101100111011111;
	  end
	  st_st16: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st16_n;
		rtext <= 'b1101100111011111;
	  end
	  st_st16_n: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b0010000011000000;
	  end
	  st_st17: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st17_n;
		rtext <= 'b0010000011000000;
	  end
	  st_st17_n: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b1011000011100001;
	  end
	  st_st18: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1 )
 		  NextState <= st_st19;
		rtext <= 'b0100100100011110;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b1110111111011111;
	  end
	  st_st20: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b1101111111011111;
	  end
	  st_st21: begin
		if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b1101111111011111;
	  end
	  st_st21_n: begin
		if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b0000100100000100;
	  end
	  st_st22: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0 )
 		  NextState <= st_st23;
		rtext <= 'b1111100111111111;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'b1011011011100001;
	  end
	  st_st24: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b1101011111000101;
	  end
	  st_st25: begin
		if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st25_n;
		rtext <= 'b1101011111000101;
	  end
	  st_st25_n: begin
		if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b1100100100011111;
	  end
	  st_st26: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st25;
		else if(ptext[2] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b0001010011000001;
	  end
	  st_st27: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b0010110111000101;
	  end
	  st_st28: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st28_n;
		rtext <= 'b0010110111000101;
	  end
	  st_st28_n: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b0011110111100101;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st30;
		rtext <= 'b1010011011000001;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b1111000111100101;
	  end
	  st_st31: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0 )
 		  NextState <= st_st31_n;
		rtext <= 'b1111000111100101;
	  end
	  st_st31_n: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b1110011111000101;
	  end
	  st_st32: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b1100000100000101;
	  end
	  st_st33: begin
		if(1)
 		  NextState <= st_st34;
		rtext <= 'b1010111111000101;
	  end
	  st_st34: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b0011000011100000;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b0010100111000100;
	  end
	  st_st36: begin
		if(1)
 		  NextState <= st_st37;
		rtext <= 'b1101000111000101;
	  end
	  st_st37: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1 )
 		  NextState <= st_st37_n;
		rtext <= 'b1101000111000101;
	  end
	  st_st37_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b0011010011100001;
	  end
	  st_st38: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1 )
 		  NextState <= st_st39;
		rtext <= 'b1110000111000101;
	  end
	  st_st39: begin
		if(1)
 		  NextState <= st_st40;
		rtext <= 'b1110100111011111;
	  end
	  st_st40: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st40_n;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st41;
		rtext <= 'b1110100111011111;
	  end
	  st_st40_n: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st41;
		rtext <= 'b1100011100000101;
	  end
	  st_st41: begin
		if(1)
 		  NextState <= st_st42;
		rtext <= 'b1010100111000101;
	  end
	  st_st42: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 0 )
 		  NextState <= st_st43;
		rtext <= 'b0000110100000101;
	  end
	  st_st43: begin
		if(1)
 		  NextState <= st_st44;
		rtext <= 'b1111011111100101;
	  end
	  st_st44: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st44_n;
		rtext <= 'b1111011111100101;
	  end
	  st_st44_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st44;
		rtext <= 'b0010010011000001;
	  end
	  st_st45: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1 )
 		  NextState <= st_st45_n;
		rtext <= 'b0010010011000001;
	  end
	  st_st45_n: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1 )
 		  NextState <= st_st45;
		rtext <= 'b1011111111100101;
	  end
	  st_st46: begin
		if(1)
 		  NextState <= st_st47;
		rtext <= 'b0001000011000000;
	  end
	  st_st47: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st46;
		else if(ptext[1] == 0 )
 		  NextState <= st_st48;
		rtext <= 'b1100111100011111;
	  end
	  st_st48: begin
		if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st47;
		else if(ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st48_n;
		rtext <= 'b1100111100011111;
	  end
	  st_st48_n: begin
		if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st47;
		else if(ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st48;
		rtext <= 'b1100111100011111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
