module fsm_rd_101_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [14:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_101_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 0  && ptext[10] == 0  && ptext[12] == 1 )
 		  NextState <= st_st2;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 0  && ptext[12] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[4] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st14;
		else if(ptext[4] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[4] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[12] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st1_n;
		rtext <= 'b010001000110;
	  end
	  st_st1_n: begin
		if(ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 0  && ptext[10] == 0  && ptext[12] == 1 )
 		  NextState <= st_st2;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 0  && ptext[12] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st14;
		else if(ptext[4] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[4] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[12] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b001100001010;
	  end
	  st_st10: begin
		if(ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st31;
		else if(ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st10_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st10_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b001100001010;
	  end
	  st_st10_n: begin
		if(ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st31;
		else if(ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b110010011011;
	  end
	  st_st11: begin
		if(ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 1 )
 		  NextState <= st_st15;
		else if(ptext[7] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[5] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st26;
		else if(ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st26;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[14] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[14] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[11] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[14] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[14] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 1  && ptext[14] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b110010011011;
	  end
	  st_st11_n: begin
		if(ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 1 )
 		  NextState <= st_st15;
		else if(ptext[7] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st11;
		else if(ptext[5] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st11;
		else if(ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st26;
		else if(ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st26;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[14] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[14] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[11] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[14] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[14] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 1  && ptext[14] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b111011010100;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b011010010101;
	  end
	  st_st13: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b111110010111;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b001010001100;
	  end
	  st_st15: begin
		if(ptext[13] == 0  && ptext[14] == 1 )
 		  NextState <= st_st16;
		else if(ptext[13] == 1 )
 		  NextState <= st_st11;
		else if(ptext[4] == 0  && ptext[10] == 0  && ptext[13] == 0 )
 		  NextState <= st_st16;
		else if(ptext[4] == 1  && ptext[14] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[10] == 1  && ptext[14] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[13] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[13] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[10] == 1  && ptext[14] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b000010100001;
	  end
	  st_st16: begin
		if(ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[8] == 0 )
 		  NextState <= st_st17;
		else if(ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16_n;
		rtext <= 'b000010100001;
	  end
	  st_st16_n: begin
		if(ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[8] == 0 )
 		  NextState <= st_st17;
		else if(ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st16;
		else if(ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b100000100110;
	  end
	  st_st17: begin
		if(ptext[11] == 1 )
 		  NextState <= st_st16;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st18;
		else if(ptext[6] == 0  && ptext[11] == 0 )
 		  NextState <= st_st18;
		else if(ptext[6] == 1  && ptext[12] == 1 )
 		  NextState <= st_st16;
		else if(ptext[5] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st18;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[7] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b100101100101;
	  end
	  st_st18: begin
		if(ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st19;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st19;
		else if(ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[8] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b111011011001;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b000001000111;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b111111111100;
	  end
	  st_st21: begin
		if(ptext[14] == 1 )
 		  NextState <= st_st20;
		else if(ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st1;
		else if(ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st20;
		else if(ptext[6] == 0  && ptext[7] == 1  && ptext[13] == 0 )
 		  NextState <= st_st20;
		else if(ptext[5] == 0  && ptext[7] == 0  && ptext[14] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[14] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 1  && ptext[13] == 0 )
 		  NextState <= st_st20;
		rtext <= 'b011010100011;
	  end
	  st_st22: begin
		if(1)
 		  NextState <= st_st23;
		rtext <= 'b100010110110;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'b101100011001;
	  end
	  st_st24: begin
		if(1)
 		  NextState <= st_st25;
		rtext <= 'b111100001101;
	  end
	  st_st25: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b001010011001;
	  end
	  st_st26: begin
		if(1)
 		  NextState <= st_st27;
		rtext <= 'b101110101010;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st28;
		rtext <= 'b011111010101;
	  end
	  st_st28: begin
		if(ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st27;
		else if(ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st27;
		else if(ptext[6] == 0  && ptext[11] == 0 )
 		  NextState <= st_st29;
		else if(ptext[6] == 0  && ptext[10] == 1  && ptext[12] == 1 )
 		  NextState <= st_st29;
		else if(ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st27;
		rtext <= 'b111010010010;
	  end
	  st_st29: begin
		if(ptext[8] == 0 )
 		  NextState <= st_st30;
		else if(ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[3] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[0] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[8] == 1 )
 		  NextState <= st_st29_n;
		rtext <= 'b111010010010;
	  end
	  st_st29_n: begin
		if(ptext[8] == 0 )
 		  NextState <= st_st30;
		else if(ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st29;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[3] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[8] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b110011101001;
	  end
	  st_st30: begin
		if(ptext[3] == 0  && ptext[13] == 0 )
 		  NextState <= st_st29;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[10] == 1  && ptext[12] == 1 )
 		  NextState <= st_st29;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1  && ptext[9] == 0  && ptext[12] == 0  && ptext[13] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[9] == 0  && ptext[10] == 0  && ptext[13] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[13] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b110010010001;
	  end
	  st_st31: begin
		if(1)
 		  NextState <= st_st27;
		rtext <= 'b101010000100;
	  end
	  st_st32: begin
		if(1)
 		  NextState <= st_st33;
		rtext <= 'b101100100110;
	  end
	  st_st33: begin
		if(ptext[9] == 0  && ptext[12] == 1  && ptext[13] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[9] == 1 )
 		  NextState <= st_st34;
		else if(ptext[4] == 0  && ptext[12] == 0 )
 		  NextState <= st_st34;
		else if(ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[4] == 1  && ptext[9] == 0 )
 		  NextState <= st_st33_n;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[1] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st33_n;
		rtext <= 'b101100100110;
	  end
	  st_st33_n: begin
		if(ptext[9] == 0  && ptext[12] == 1  && ptext[13] == 1 )
 		  NextState <= st_st33;
		else if(ptext[9] == 1 )
 		  NextState <= st_st34;
		else if(ptext[4] == 0  && ptext[12] == 0 )
 		  NextState <= st_st34;
		else if(ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[4] == 1  && ptext[9] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st33;
		rtext <= 'b001010000111;
	  end
	  st_st34: begin
		if(ptext[7] == 0 )
 		  NextState <= st_st33;
		else if(ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st38;
		else if(ptext[5] == 0  && ptext[9] == 1  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[9] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[7] == 1  && ptext[13] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[7] == 1  && ptext[11] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[9] == 1 )
 		  NextState <= st_st33;
		rtext <= 'b101010011011;
	  end
	  st_st38: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st38_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st38_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st38_n;
		rtext <= 'b101010011011;
	  end
	  st_st38_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st38;
		rtext <= 'b010000110001;
	  end
	  st_st5: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st6;
		rtext <= 'b010000110001;
	  end
	  st_st5_n: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st6;
		rtext <= 'b111101001100;
	  end
	  st_st6: begin
		if(ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[9] == 0  && ptext[10] == 0  && ptext[13] == 1 )
 		  NextState <= st_st7;
		else if(ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[7] == 1  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6_n;
		else if(ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[3] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st6_n;
		else if(ptext[3] == 1  && ptext[10] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b111101001100;
	  end
	  st_st6_n: begin
		if(ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[9] == 0  && ptext[10] == 0  && ptext[13] == 1 )
 		  NextState <= st_st7;
		else if(ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[7] == 1  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st6;
		else if(ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[3] == 1  && ptext[10] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b001100001111;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b101011010010;
	  end
	  st_st8: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b000010001001;
	  end
	  st_st9: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b000010001001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
