module fsm_rd_105_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [5:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_105_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b11110101;
	  end
	  st_st1_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b01000000;
	  end
	  st_st2: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b11000000;
	  end
	  st_st3: begin
		if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3_n;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3_n;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3_n;
		rtext <= 'b11000000;
	  end
	  st_st3_n: begin
		if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b11111111;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4_n;
		rtext <= 'b11111111;
	  end
	  st_st4_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b01010010;
	  end
	  st_st5: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b01010010;
	  end
	  st_st5_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b11111010;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b00000110;
	  end
	  st_st7: begin
		if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7_n;
		rtext <= 'b00000110;
	  end
	  st_st7_n: begin
		if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01000011;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st8_n;
		rtext <= 'b01000011;
	  end
	  st_st8_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b00101010;
	  end
	  st_st9: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st42;
		rtext <= 'b00101010;
	  end
	  st_st9_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st42;
		rtext <= 'b10111000;
	  end
	  st_st10: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st10_n;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10_n;
		rtext <= 'b10111000;
	  end
	  st_st10_n: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b10001110;
	  end
	  st_st11: begin
		if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b11101100;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b10001011;
	  end
	  st_st13: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st13_n;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b10001011;
	  end
	  st_st13_n: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b01011010;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b00011101;
	  end
	  st_st15: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st15_n;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st15_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st15_n;
		rtext <= 'b00011101;
	  end
	  st_st15_n: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b10111110;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16_n;
		rtext <= 'b10111110;
	  end
	  st_st16_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b11111001;
	  end
	  st_st17: begin
		if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st17_n;
		rtext <= 'b11111001;
	  end
	  st_st17_n: begin
		if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b00011011;
	  end
	  st_st18: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18_n;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st18_n;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st18_n;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18_n;
		rtext <= 'b00011011;
	  end
	  st_st18_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st18;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b00011011;
	  end
	  st_st19: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st20;
		else if(ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st19_n;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st19_n;
		rtext <= 'b00011011;
	  end
	  st_st19_n: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st20;
		else if(ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b11011101;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b01100110;
	  end
	  st_st21: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st21_n;
		rtext <= 'b01100110;
	  end
	  st_st21_n: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b01011111;
	  end
	  st_st22: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22_n;
		rtext <= 'b01011111;
	  end
	  st_st22_n: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b01101110;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'b01111001;
	  end
	  st_st24: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st24_n;
		rtext <= 'b01111001;
	  end
	  st_st24_n: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b10011011;
	  end
	  st_st25: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st26;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st26;
		rtext <= 'b00101011;
	  end
	  st_st26: begin
		if(1)
 		  NextState <= st_st27;
		rtext <= 'b00010011;
	  end
	  st_st27: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st27_n;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st27_n;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st27_n;
		rtext <= 'b00010011;
	  end
	  st_st27_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st27;
		rtext <= 'b10011000;
	  end
	  st_st28: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st29;
		else if(ptext[4] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st28_n;
		rtext <= 'b10011000;
	  end
	  st_st28_n: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st29;
		else if(ptext[4] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b01101100;
	  end
	  st_st29: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b10111101;
	  end
	  st_st30: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b10011011;
	  end
	  st_st31: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st30;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st30;
		else if(ptext[3] == 0 )
 		  NextState <= st_st30;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st32;
		rtext <= 'b11000111;
	  end
	  st_st32: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b00111011;
	  end
	  st_st33: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st33_n;
		rtext <= 'b00111011;
	  end
	  st_st33_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st33;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st33;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b01100000;
	  end
	  st_st34: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b00111001;
	  end
	  st_st35: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35_n;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35_n;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35_n;
		rtext <= 'b00111001;
	  end
	  st_st35_n: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b11110010;
	  end
	  st_st36: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st36_n;
		rtext <= 'b11110010;
	  end
	  st_st36_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b10110110;
	  end
	  st_st37: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st37_n;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st38;
		else if(ptext[4] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st37_n;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st37_n;
		rtext <= 'b10110110;
	  end
	  st_st37_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st38;
		else if(ptext[4] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st37;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st37;
		rtext <= 'b10100100;
	  end
	  st_st38: begin
		if(1)
 		  NextState <= st_st39;
		rtext <= 'b10111101;
	  end
	  st_st39: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 1 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st39_n;
		rtext <= 'b10111101;
	  end
	  st_st39_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 1 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st39;
		rtext <= 'b01001010;
	  end
	  st_st40: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st40_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st39;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st41;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st40_n;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st40_n;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st40_n;
		rtext <= 'b01001010;
	  end
	  st_st40_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st39;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st41;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st40;
		rtext <= 'b01100011;
	  end
	  st_st41: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b01000101;
	  end
	  st_st42: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st42_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st42_n;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st42_n;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st42_n;
		rtext <= 'b01000101;
	  end
	  st_st42_n: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st42;
		rtext <= 'b11010000;
	  end
	  st_st43: begin
		if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st42;
		else if(ptext[5] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st44;
		else if(ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st44;
		rtext <= 'b10100110;
	  end
	  st_st44: begin
		if(1)
 		  NextState <= st_st45;
		rtext <= 'b00000001;
	  end
	  st_st45: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st46;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st45_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st44;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st46;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st46;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st45_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st45_n;
		else if(ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st45_n;
		rtext <= 'b00000001;
	  end
	  st_st45_n: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st46;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st45;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st44;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st46;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st46;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st45;
		else if(ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st45;
		rtext <= 'b01110101;
	  end
	  st_st46: begin
		if(1)
 		  NextState <= st_st47;
		rtext <= 'b11001101;
	  end
	  st_st47: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st48;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st47_n;
		else if(ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[2] == 0 )
 		  NextState <= st_st48;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st47_n;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st47_n;
		rtext <= 'b11001101;
	  end
	  st_st47_n: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st48;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st47;
		else if(ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[2] == 0 )
 		  NextState <= st_st48;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st47;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st47;
		rtext <= 'b10101111;
	  end
	  st_st48: begin
		if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st48_n;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[2] == 1 )
 		  NextState <= st_st49;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st48_n;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st48_n;
		rtext <= 'b10101111;
	  end
	  st_st48_n: begin
		if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st48;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[2] == 1 )
 		  NextState <= st_st49;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st48;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st48;
		rtext <= 'b10010110;
	  end
	  st_st49: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st49_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st49_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49_n;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st49_n;
		rtext <= 'b10010110;
	  end
	  st_st49_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st49;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st49;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st49;
		rtext <= 'b10101011;
	  end
	  st_st50: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b10101011;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
