module fsm_rd_106_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [14:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_106_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[6] == 0  && ptext[10] == 1  && ptext[12] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[12] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[10] == 0  && ptext[12] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[11] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[12] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b100000101010;
	  end
	  st_st1_n: begin
		if(ptext[0] == 0  && ptext[6] == 0  && ptext[10] == 1  && ptext[12] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[12] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[10] == 0  && ptext[12] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[11] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[12] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b100001110111;
	  end
	  st_st2: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[7] == 1  && ptext[12] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[9] == 0  && ptext[12] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[12] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b001001010011;
	  end
	  st_st3: begin
		if(ptext[6] == 1  && ptext[7] == 0  && ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st2;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st4;
		else if(ptext[6] == 1  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st2;
		else if(ptext[5] == 0  && ptext[14] == 0 )
 		  NextState <= st_st2;
		else if(ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[11] == 1 )
 		  NextState <= st_st4;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[4] == 1  && ptext[14] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b001101110011;
	  end
	  st_st4: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[14] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[8] == 1  && ptext[12] == 1  && ptext[14] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st5;
		else if(ptext[12] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[12] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[2] == 0  && ptext[12] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b001101110011;
	  end
	  st_st4_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[14] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[8] == 1  && ptext[12] == 1  && ptext[14] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st5;
		else if(ptext[12] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[12] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[12] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b001110101101;
	  end
	  st_st5: begin
		if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[14] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[14] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[14] == 0 )
 		  NextState <= st_st4;
		else if(ptext[4] == 1  && ptext[7] == 0  && ptext[14] == 1 )
 		  NextState <= st_st4;
		else if(ptext[6] == 0  && ptext[14] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[14] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[14] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1  && ptext[14] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[4] == 0  && ptext[14] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b001110101101;
	  end
	  st_st5_n: begin
		if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[14] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[14] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[14] == 0 )
 		  NextState <= st_st4;
		else if(ptext[4] == 1  && ptext[7] == 0  && ptext[14] == 1 )
 		  NextState <= st_st4;
		else if(ptext[6] == 0  && ptext[14] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[14] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[14] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1  && ptext[14] == 0 )
 		  NextState <= st_st5;
		else if(ptext[4] == 0  && ptext[14] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b111000111001;
	  end
	  st_st6: begin
		if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st34;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[13] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[13] == 0 )
 		  NextState <= st_st39;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1  && ptext[13] == 0 )
 		  NextState <= st_st7;
		else if(ptext[6] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[6] == 1  && ptext[9] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[13] == 0 )
 		  NextState <= st_st39;
		else if(ptext[6] == 1  && ptext[14] == 1 )
 		  NextState <= st_st39;
		rtext <= 'b111000111001;
	  end
	  st_st6_n: begin
		if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st34;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[13] == 0 )
 		  NextState <= st_st6;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[13] == 0 )
 		  NextState <= st_st39;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1  && ptext[13] == 0 )
 		  NextState <= st_st7;
		else if(ptext[6] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[13] == 0 )
 		  NextState <= st_st34;
		else if(ptext[6] == 1  && ptext[9] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[13] == 0 )
 		  NextState <= st_st39;
		else if(ptext[6] == 1  && ptext[14] == 1 )
 		  NextState <= st_st39;
		rtext <= 'b010100110000;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st8;
		rtext <= 'b101111000000;
	  end
	  st_st8: begin
		if(ptext[3] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[12] == 1  && ptext[14] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[12] == 1  && ptext[14] == 1 )
 		  NextState <= st_st42;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st49;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st9;
		else if(ptext[4] == 1  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[11] == 0  && ptext[12] == 1  && ptext[14] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[4] == 1  && ptext[9] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[4] == 0  && ptext[7] == 0  && ptext[14] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[4] == 0  && ptext[11] == 1  && ptext[14] == 0 )
 		  NextState <= st_st42;
		else if(ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st42;
		else if(ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st49;
		else if(ptext[4] == 1  && ptext[12] == 0 )
 		  NextState <= st_st49;
		rtext <= 'b101111000000;
	  end
	  st_st8_n: begin
		if(ptext[3] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[12] == 1  && ptext[14] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[12] == 1  && ptext[14] == 1 )
 		  NextState <= st_st42;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st49;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st9;
		else if(ptext[4] == 1  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[11] == 0  && ptext[12] == 1  && ptext[14] == 0 )
 		  NextState <= st_st8;
		else if(ptext[4] == 1  && ptext[9] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0  && ptext[7] == 0  && ptext[14] == 1 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0  && ptext[11] == 1  && ptext[14] == 0 )
 		  NextState <= st_st42;
		else if(ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st42;
		else if(ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st49;
		else if(ptext[4] == 1  && ptext[12] == 0 )
 		  NextState <= st_st49;
		rtext <= 'b110111110011;
	  end
	  st_st9: begin
		if(1)
 		  NextState <= st_st10;
		rtext <= 'b100100010110;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b001110010011;
	  end
	  st_st11: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b100011001111;
	  end
	  st_st12: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[10] == 0  && ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[11] == 0  && ptext[12] == 0  && ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0  && ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[10] == 0  && ptext[14] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[12] == 1  && ptext[13] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[11] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 1  && ptext[14] == 0 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0  && ptext[10] == 1  && ptext[12] == 0  && ptext[13] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[11] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0  && ptext[10] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 0  && ptext[13] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b001011101111;
	  end
	  st_st13: begin
		if(1)
 		  NextState <= st_st14;
		rtext <= 'b101101000110;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b000001111011;
	  end
	  st_st15: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[7] == 1  && ptext[12] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[12] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st14;
		else if(ptext[3] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b010110000001;
	  end
	  st_st16: begin
		if(1)
 		  NextState <= st_st17;
		rtext <= 'b101100111000;
	  end
	  st_st17: begin
		if(1)
 		  NextState <= st_st18;
		rtext <= 'b001000010000;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st19;
		rtext <= 'b001001100011;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b000111101000;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b011001001010;
	  end
	  st_st21: begin
		if(ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st12;
		else if(ptext[11] == 1  && ptext[12] == 0  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st22;
		else if(ptext[6] == 1  && ptext[8] == 1  && ptext[14] == 1 )
 		  NextState <= st_st12;
		else if(ptext[8] == 1  && ptext[13] == 1 )
 		  NextState <= st_st12;
		else if(ptext[11] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 0  && ptext[11] == 1  && ptext[13] == 0  && ptext[14] == 0 )
 		  NextState <= st_st22;
		else if(ptext[6] == 0  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st22;
		else if(ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b011100100001;
	  end
	  st_st22: begin
		if(ptext[0] == 0  && ptext[4] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[9] == 0  && ptext[11] == 1  && ptext[12] == 1  && ptext[13] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[4] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[9] == 1  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[11] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[9] == 0  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[11] == 1  && ptext[14] == 0 )
 		  NextState <= st_st22_n;
		rtext <= 'b011100100001;
	  end
	  st_st22_n: begin
		if(ptext[0] == 0  && ptext[4] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[9] == 0  && ptext[11] == 1  && ptext[12] == 1  && ptext[13] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[9] == 1  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[11] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[9] == 0  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st22;
		else if(ptext[11] == 1  && ptext[14] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b110010011000;
	  end
	  st_st23: begin
		if(ptext[1] == 1  && ptext[7] == 0  && ptext[11] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 0  && ptext[11] == 1  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st23_n;
		else if(ptext[8] == 0  && ptext[11] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st22;
		else if(ptext[7] == 0  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[7] == 0  && ptext[8] == 1  && ptext[12] == 0  && ptext[14] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[14] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[8] == 1  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st23_n;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[12] == 1  && ptext[14] == 1 )
 		  NextState <= st_st23_n;
		else if(ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st23_n;
		rtext <= 'b110010011000;
	  end
	  st_st23_n: begin
		if(ptext[1] == 1  && ptext[7] == 0  && ptext[11] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 0  && ptext[11] == 1  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[8] == 0  && ptext[11] == 0  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st22;
		else if(ptext[7] == 0  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[7] == 0  && ptext[8] == 1  && ptext[12] == 0  && ptext[14] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[14] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[8] == 1  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[12] == 1  && ptext[14] == 1 )
 		  NextState <= st_st23;
		else if(ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b010011111100;
	  end
	  st_st24: begin
		if(1)
 		  NextState <= st_st25;
		rtext <= 'b010000100111;
	  end
	  st_st25: begin
		if(1)
 		  NextState <= st_st26;
		rtext <= 'b100000101011;
	  end
	  st_st26: begin
		if(ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[9] == 1  && ptext[12] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[0] == 0  && ptext[10] == 0  && ptext[14] == 1 )
 		  NextState <= st_st27;
		else if(ptext[9] == 0  && ptext[14] == 1 )
 		  NextState <= st_st27;
		else if(ptext[3] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st26_n;
		else if(ptext[3] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[3] == 0  && ptext[14] == 0 )
 		  NextState <= st_st26_n;
		rtext <= 'b100000101011;
	  end
	  st_st26_n: begin
		if(ptext[10] == 0  && ptext[11] == 1  && ptext[12] == 0  && ptext[14] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[9] == 1  && ptext[12] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[10] == 0  && ptext[14] == 1 )
 		  NextState <= st_st27;
		else if(ptext[9] == 0  && ptext[14] == 1 )
 		  NextState <= st_st27;
		else if(ptext[3] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st26;
		else if(ptext[3] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 0  && ptext[14] == 0 )
 		  NextState <= st_st26;
		rtext <= 'b001011100000;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b001011101000;
	  end
	  st_st28: begin
		if(1)
 		  NextState <= st_st29;
		rtext <= 'b011111011001;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st30;
		rtext <= 'b011000100000;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b100010011111;
	  end
	  st_st31: begin
		if(1)
 		  NextState <= st_st32;
		rtext <= 'b111111011000;
	  end
	  st_st32: begin
		if(1)
 		  NextState <= st_st33;
		rtext <= 'b110110001111;
	  end
	  st_st33: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[10] == 0  && ptext[14] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[14] == 0 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[14] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b010111110110;
	  end
	  st_st34: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[12] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[11] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st34_n;
		else if(ptext[0] == 1  && ptext[11] == 0 )
 		  NextState <= st_st34_n;
		rtext <= 'b010111110110;
	  end
	  st_st34_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[12] == 0 )
 		  NextState <= st_st34;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[11] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[11] == 0 )
 		  NextState <= st_st34;
		rtext <= 'b000111010000;
	  end
	  st_st35: begin
		if(ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[13] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[13] == 1 )
 		  NextState <= st_st35_n;
		else if(ptext[1] == 0  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st35_n;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[11] == 1 )
 		  NextState <= st_st35_n;
		else if(ptext[0] == 0  && ptext[10] == 0 )
 		  NextState <= st_st35_n;
		rtext <= 'b000111010000;
	  end
	  st_st35_n: begin
		if(ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 0  && ptext[13] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[13] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[11] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[10] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b110000001100;
	  end
	  st_st36: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[8] == 0  && ptext[12] == 1 )
 		  NextState <= st_st37;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[8] == 1  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st35;
		else if(ptext[4] == 1  && ptext[8] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st37;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[12] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[8] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st36_n;
		rtext <= 'b110000001100;
	  end
	  st_st36_n: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[8] == 0  && ptext[12] == 1 )
 		  NextState <= st_st37;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[11] == 0  && ptext[12] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[8] == 1  && ptext[12] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st35;
		else if(ptext[4] == 1  && ptext[8] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st37;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[8] == 0  && ptext[11] == 1  && ptext[12] == 0 )
 		  NextState <= st_st36;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[12] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[8] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b110010100000;
	  end
	  st_st37: begin
		if(1)
 		  NextState <= st_st38;
		rtext <= 'b111111011111;
	  end
	  st_st38: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b111010001010;
	  end
	  st_st39: begin
		if(ptext[3] == 1  && ptext[8] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st40;
		else if(ptext[6] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st40;
		else if(ptext[5] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st40;
		else if(ptext[5] == 0  && ptext[10] == 1 )
 		  NextState <= st_st40;
		rtext <= 'b100100011000;
	  end
	  st_st40: begin
		if(1)
 		  NextState <= st_st41;
		rtext <= 'b100110000001;
	  end
	  st_st41: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b111000101011;
	  end
	  st_st42: begin
		if(ptext[5] == 1  && ptext[9] == 0  && ptext[11] == 0  && ptext[14] == 0 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0  && ptext[8] == 1  && ptext[11] == 1  && ptext[13] == 0 )
 		  NextState <= st_st43;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[14] == 0 )
 		  NextState <= st_st8;
		else if(ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st8;
		else if(ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[13] == 0 )
 		  NextState <= st_st43;
		else if(ptext[8] == 1  && ptext[9] == 1  && ptext[13] == 0 )
 		  NextState <= st_st43;
		else if(ptext[8] == 1  && ptext[14] == 1 )
 		  NextState <= st_st43;
		rtext <= 'b100011011110;
	  end
	  st_st43: begin
		if(ptext[1] == 0  && ptext[10] == 0  && ptext[12] == 0  && ptext[14] == 0 )
 		  NextState <= st_st44;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st43_n;
		else if(ptext[1] == 0  && ptext[12] == 0  && ptext[13] == 0 )
 		  NextState <= st_st44;
		else if(ptext[2] == 1  && ptext[12] == 0 )
 		  NextState <= st_st44;
		else if(ptext[3] == 0 )
 		  NextState <= st_st44;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[10] == 1  && ptext[13] == 1 )
 		  NextState <= st_st43_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st43_n;
		else if(ptext[3] == 1  && ptext[12] == 1 )
 		  NextState <= st_st43_n;
		rtext <= 'b100011011110;
	  end
	  st_st43_n: begin
		if(ptext[1] == 0  && ptext[10] == 0  && ptext[12] == 0  && ptext[14] == 0 )
 		  NextState <= st_st44;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st43;
		else if(ptext[1] == 0  && ptext[12] == 0  && ptext[13] == 0 )
 		  NextState <= st_st44;
		else if(ptext[2] == 1  && ptext[12] == 0 )
 		  NextState <= st_st44;
		else if(ptext[3] == 0 )
 		  NextState <= st_st44;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[10] == 1  && ptext[13] == 1 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st43;
		else if(ptext[3] == 1  && ptext[12] == 1 )
 		  NextState <= st_st43;
		rtext <= 'b101000000111;
	  end
	  st_st44: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st44_n;
		else if(ptext[4] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st43;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st45;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st44_n;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st44_n;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st44_n;
		rtext <= 'b101000000111;
	  end
	  st_st44_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st44;
		else if(ptext[4] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st43;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st45;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st44;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st44;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st44;
		rtext <= 'b010010100000;
	  end
	  st_st45: begin
		if(1)
 		  NextState <= st_st46;
		rtext <= 'b010110000110;
	  end
	  st_st46: begin
		if(1)
 		  NextState <= st_st47;
		rtext <= 'b010001110111;
	  end
	  st_st47: begin
		if(ptext[2] == 1  && ptext[11] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st47_n;
		else if(ptext[2] == 1  && ptext[10] == 1  && ptext[13] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st48;
		else if(ptext[9] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st47_n;
		else if(ptext[0] == 1  && ptext[9] == 1  && ptext[13] == 0 )
 		  NextState <= st_st47_n;
		else if(ptext[2] == 0  && ptext[9] == 1 )
 		  NextState <= st_st47_n;
		rtext <= 'b010001110111;
	  end
	  st_st47_n: begin
		if(ptext[2] == 1  && ptext[11] == 0  && ptext[13] == 1  && ptext[14] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st47;
		else if(ptext[2] == 1  && ptext[10] == 1  && ptext[13] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st48;
		else if(ptext[9] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st47;
		else if(ptext[0] == 1  && ptext[9] == 1  && ptext[13] == 0 )
 		  NextState <= st_st47;
		else if(ptext[2] == 0  && ptext[9] == 1 )
 		  NextState <= st_st47;
		rtext <= 'b000111000001;
	  end
	  st_st48: begin
		if(1)
 		  NextState <= st_st41;
		rtext <= 'b110010101011;
	  end
	  st_st49: begin
		if(1)
 		  NextState <= st_st50;
		rtext <= 'b110011111101;
	  end
	  st_st50: begin
		if(1)
 		  NextState <= st_st51;
		rtext <= 'b111110111110;
	  end
	  st_st51: begin
		if(1)
 		  NextState <= st_st52;
		rtext <= 'b100000001010;
	  end
	  st_st52: begin
		if(1)
 		  NextState <= st_st53;
		rtext <= 'b011111011011;
	  end
	  st_st53: begin
		if(1)
 		  NextState <= st_st54;
		rtext <= 'b001001011001;
	  end
	  st_st54: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st53;
		else if(ptext[4] == 1  && ptext[10] == 0  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 0  && ptext[7] == 1  && ptext[12] == 0 )
 		  NextState <= st_st53;
		else if(ptext[7] == 1  && ptext[11] == 1 )
 		  NextState <= st_st53;
		else if(ptext[10] == 1 )
 		  NextState <= st_st53;
		else if(ptext[2] == 0  && ptext[10] == 0  && ptext[11] == 0  && ptext[12] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st41;
		else if(ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st41;
		rtext <= 'b111101111111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
