module fsm_rd_107_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [7:0] ptext;
	output[5:0] rtext;
	reg [5:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_107_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b11101x;
	  end
	  st_st1_n: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b000x10;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2_n;
		rtext <= 'b000x10;
	  end
	  st_st2_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2;
		rtext <= 'b110000;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b111010;
	  end
	  st_st4: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b111010;
	  end
	  st_st4_n: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b011011;
	  end
	  st_st5: begin
		if(ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b010011;
	  end
	  st_st6: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st6_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b010011;
	  end
	  st_st6_n: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b110001;
	  end
	  st_st7: begin
		if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		rtext <= 'b110001;
	  end
	  st_st7_n: begin
		if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b1x0111;
	  end
	  st_st8: begin
		if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b110111;
	  end
	  st_st9: begin
		if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9_n;
		rtext <= 'b110111;
	  end
	  st_st9_n: begin
		if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b101x10;
	  end
	  st_st10: begin
		if(ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b010100;
	  end
	  st_st11: begin
		if(ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		rtext <= 'bx00111;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b10011x;
	  end
	  st_st13: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st13_n;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st13_n;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st13_n;
		rtext <= 'b10011x;
	  end
	  st_st13_n: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b110000;
	  end
	  st_st14: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14_n;
		rtext <= 'b110000;
	  end
	  st_st14_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		rtext <= 'bx11100;
	  end
	  st_st15: begin
		if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st15_n;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st30;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st15_n;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st30;
		rtext <= 'bx11100;
	  end
	  st_st15_n: begin
		if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st30;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st30;
		rtext <= 'bxx1101;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st15;
		else if(ptext[2] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b111011;
	  end
	  st_st17: begin
		if(1)
 		  NextState <= st_st18;
		rtext <= 'b001001;
	  end
	  st_st18: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st18_n;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b001001;
	  end
	  st_st18_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b100100;
	  end
	  st_st19: begin
		if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st20;
		else if(ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b101111;
	  end
	  st_st20: begin
		if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20_n;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st20_n;
		else if(ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st20_n;
		rtext <= 'b101111;
	  end
	  st_st20_n: begin
		if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b10x110;
	  end
	  st_st21: begin
		if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22;
		else if(ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21_n;
		rtext <= 'b10x110;
	  end
	  st_st21_n: begin
		if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22;
		else if(ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b100000;
	  end
	  st_st22: begin
		if(ptext[1] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22_n;
		rtext <= 'b100000;
	  end
	  st_st22_n: begin
		if(ptext[1] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b00100x;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b001010;
	  end
	  st_st24: begin
		if(1)
 		  NextState <= st_st25;
		rtext <= 'b101010;
	  end
	  st_st25: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25_n;
		else if(ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25_n;
		rtext <= 'b101010;
	  end
	  st_st25_n: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b010010;
	  end
	  st_st26: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st26_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st26_n;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b010010;
	  end
	  st_st26_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b011000;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b101001;
	  end
	  st_st28: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st28_n;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st28_n;
		rtext <= 'b101001;
	  end
	  st_st28_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b101x10;
	  end
	  st_st29: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st29_n;
		else if(ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st29_n;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st29_n;
		rtext <= 'b101x10;
	  end
	  st_st29_n: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st29;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st29;
		rtext <= 'b110100;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b110000;
	  end
	  st_st31: begin
		if(1)
 		  NextState <= st_st32;
		rtext <= 'b100000;
	  end
	  st_st32: begin
		if(ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[0] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32_n;
		rtext <= 'b100000;
	  end
	  st_st32_n: begin
		if(ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b100110;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
