module fsm_rd_112_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [6:0] ptext;
	output[4:0] rtext;
	reg [4:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_112_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b01001;
	  end
	  st_st1_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b00110;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2_n;
		rtext <= 'b00110;
	  end
	  st_st2_n: begin
		if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b10010;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b01100;
	  end
	  st_st4: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b01100;
	  end
	  st_st4_n: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b00011;
	  end
	  st_st5: begin
		if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st5_n;
		rtext <= 'b00011;
	  end
	  st_st5_n: begin
		if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00101;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b10101;
	  end
	  st_st7: begin
		if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st7_n;
		rtext <= 'b10101;
	  end
	  st_st7_n: begin
		if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01011;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8_n;
		rtext <= 'b01011;
	  end
	  st_st8_n: begin
		if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b01001;
	  end
	  st_st9: begin
		if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0 )
 		  NextState <= st_st9_n;
		rtext <= 'b01001;
	  end
	  st_st9_n: begin
		if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b11011;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b10000;
	  end
	  st_st11: begin
		if(ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b01100;
	  end
	  st_st12: begin
		if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b01111;
	  end
	  st_st13: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st13_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b01111;
	  end
	  st_st13_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b01111;
	  end
	  st_st14: begin
		if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b11010;
	  end
	  st_st15: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b10100;
	  end
	  st_st16: begin
		if(ptext[0] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st17;
		else if(ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b00001;
	  end
	  st_st17: begin
		if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st17_n;
		rtext <= 'b00001;
	  end
	  st_st17_n: begin
		if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b10100;
	  end
	  st_st18: begin
		if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st19;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st18_n;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18_n;
		rtext <= 'b10100;
	  end
	  st_st18_n: begin
		if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st19;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b01100;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b10110;
	  end
	  st_st20: begin
		if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st20_n;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b10110;
	  end
	  st_st20_n: begin
		if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b00001;
	  end
	  st_st21: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st21_n;
		rtext <= 'b00001;
	  end
	  st_st21_n: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b11001;
	  end
	  st_st22: begin
		if(1)
 		  NextState <= st_st16;
		rtext <= 'b00000;
	  end
	  st_st23: begin
		if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		rtext <= 'b01011;
	  end
	  st_st24: begin
		if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24_n;
		rtext <= 'b01011;
	  end
	  st_st24_n: begin
		if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b10000;
	  end
	  st_st25: begin
		if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st25_n;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st25_n;
		rtext <= 'b10000;
	  end
	  st_st25_n: begin
		if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b11001;
	  end
	  st_st26: begin
		if(1)
 		  NextState <= st_st27;
		rtext <= 'b00100;
	  end
	  st_st27: begin
		if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st27_n;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st27_n;
		rtext <= 'b00100;
	  end
	  st_st27_n: begin
		if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b00011;
	  end
	  st_st28: begin
		if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28_n;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[5] == 1 )
 		  NextState <= st_st28_n;
		rtext <= 'b00011;
	  end
	  st_st28_n: begin
		if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[5] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b10001;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st16;
		rtext <= 'b01100;
	  end
	  st_st30: begin
		if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st31;
		else if(ptext[2] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b01101;
	  end
	  st_st31: begin
		if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st31_n;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31_n;
		rtext <= 'b01101;
	  end
	  st_st31_n: begin
		if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b00100;
	  end
	  st_st32: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st32_n;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st32_n;
		rtext <= 'b00100;
	  end
	  st_st32_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st32;
		rtext <= 'b11101;
	  end
	  st_st33: begin
		if(1)
 		  NextState <= st_st34;
		rtext <= 'b00110;
	  end
	  st_st34: begin
		if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0 )
 		  NextState <= st_st34_n;
		rtext <= 'b00110;
	  end
	  st_st34_n: begin
		if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0 )
 		  NextState <= st_st34;
		rtext <= 'b00010;
	  end
	  st_st35: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st34;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st35_n;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st35_n;
		rtext <= 'b00010;
	  end
	  st_st35_n: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st34;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b00110;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
