module fsm_rd_130_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[4:0] rtext;
	reg [4:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_130_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b10010;
	  end
	  st_st1_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b01000;
	  end
	  st_st2: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b00100;
	  end
	  st_st5: begin
		if(1)
 		  NextState <= st_st6;
		rtext <= 'b00000;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b00000;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st8;
		rtext <= 'b00001;
	  end
	  st_st8: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b00001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
