module fsm_rd_139_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_139_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00001011;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00010101;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b00010101;
	  end
	  st_st2_n: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b00000000;
	  end
	  st_st3: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st3_n;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b00000000;
	  end
	  st_st3_n: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b11011010;
	  end
	  st_st4: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b11011010;
	  end
	  st_st4_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b00100001;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b00100001;
	  end
	  st_st5_n: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b11100000;
	  end
	  st_st6: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b11100000;
	  end
	  st_st6_n: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b00101110;
	  end
	  st_st7: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st7_n;
		rtext <= 'b00101110;
	  end
	  st_st7_n: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01010101;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8_n;
		rtext <= 'b01010101;
	  end
	  st_st8_n: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b01001101;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
