module fsm_rd_141_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [0:0] ptext;
	output[3:0] rtext;
	reg [3:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_141_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b0100;
	  end
	  st_st2: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b0111;
	  end
	  st_st3: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1 )
 		  NextState <= st_st3_n;
		rtext <= 'b0111;
	  end
	  st_st3_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b0010;
	  end
	  st_st4: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b0010;
	  end
	  st_st4_n: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b0011;
	  end
	  st_st5: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b0001;
	  end
	  st_st6: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b1101;
	  end
	  st_st7: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b1101;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
