module fsm_rd_150_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [6:0] ptext;
	output[8:0] rtext;
	reg [8:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_150_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b101010101;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b111000010;
	  end
	  st_st2: begin
		if(1)
 		  NextState <= st_st3;
		rtext <= 'b110110100;
	  end
	  st_st3: begin
		if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b011100011;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b110010000;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b110010000;
	  end
	  st_st5_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b011010000;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b101100010;
	  end
	  st_st7: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		rtext <= 'b101100010;
	  end
	  st_st7_n: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b000101010;
	  end
	  st_st8: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b001000001;
	  end
	  st_st9: begin
		if(1)
 		  NextState <= st_st10;
		rtext <= 'b010000010;
	  end
	  st_st10: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st10_n;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st10_n;
		rtext <= 'b010000010;
	  end
	  st_st10_n: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b010000000;
	  end
	  st_st11: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11_n;
		rtext <= 'b010000000;
	  end
	  st_st11_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st11;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b011100101;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		rtext <= 'b010001100;
	  end
	  st_st13: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b111010001;
	  end
	  st_st14: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b001100100;
	  end
	  st_st15: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b001010000;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st16_n;
		rtext <= 'b001010000;
	  end
	  st_st16_n: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b001010101;
	  end
	  st_st17: begin
		if(1)
 		  NextState <= st_st18;
		rtext <= 'b110110111;
	  end
	  st_st18: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18_n;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st18_n;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st18_n;
		rtext <= 'b110110111;
	  end
	  st_st18_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st18;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b011000010;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b010111000;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b000000100;
	  end
	  st_st21: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st21_n;
		rtext <= 'b000000100;
	  end
	  st_st21_n: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b110000001;
	  end
	  st_st22: begin
		if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st40;
		rtext <= 'b110000001;
	  end
	  st_st22_n: begin
		if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st40;
		rtext <= 'b111100000;
	  end
	  st_st23: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b001010000;
	  end
	  st_st24: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st25;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24_n;
		rtext <= 'b001010000;
	  end
	  st_st24_n: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st25;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b110001000;
	  end
	  st_st25: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st26;
		rtext <= 'b111110110;
	  end
	  st_st26: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st25;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[3] == 1 )
 		  NextState <= st_st25;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b111011000;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st22;
		rtext <= 'b111001000;
	  end
	  st_st28: begin
		if(1)
 		  NextState <= st_st29;
		rtext <= 'b111011000;
	  end
	  st_st29: begin
		if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st29_n;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st29_n;
		rtext <= 'b111011000;
	  end
	  st_st29_n: begin
		if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b011000100;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b110101000;
	  end
	  st_st31: begin
		if(1)
 		  NextState <= st_st32;
		rtext <= 'b101001001;
	  end
	  st_st32: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st32_n;
		rtext <= 'b101001001;
	  end
	  st_st32_n: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st32;
		rtext <= 'b110000000;
	  end
	  st_st33: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st16;
		else if(ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b010000111;
	  end
	  st_st34: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b110000000;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st22;
		rtext <= 'b101010000;
	  end
	  st_st36: begin
		if(1)
 		  NextState <= st_st37;
		rtext <= 'b100110000;
	  end
	  st_st37: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st37_n;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st37_n;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st37_n;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st37_n;
		rtext <= 'b100110000;
	  end
	  st_st37_n: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st37;
		rtext <= 'b011001010;
	  end
	  st_st38: begin
		if(1)
 		  NextState <= st_st39;
		rtext <= 'b111011000;
	  end
	  st_st39: begin
		if(1)
 		  NextState <= st_st40;
		rtext <= 'b111111001;
	  end
	  st_st40: begin
		if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st40_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st40_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st40_n;
		else if(ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st40_n;
		rtext <= 'b111111001;
	  end
	  st_st40_n: begin
		if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st40;
		rtext <= 'b111111001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
