module fsm_rd_151_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [6:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_151_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b10011001;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b11000010;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b11000010;
	  end
	  st_st2_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b10011000;
	  end
	  st_st3: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b10011000;
	  end
	  st_st3_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b01110011;
	  end
	  st_st4: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st3;
		else if(ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b01010111;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b01010111;
	  end
	  st_st5_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b01000000;
	  end
	  st_st6: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01000111;
	  end
	  st_st7: begin
		if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b01000010;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st8_n;
		rtext <= 'b01000010;
	  end
	  st_st8_n: begin
		if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b00111011;
	  end
	  st_st9: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b01001001;
	  end
	  st_st10: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b00101000;
	  end
	  st_st11: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st11_n;
		rtext <= 'b00101000;
	  end
	  st_st11_n: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b00101000;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12_n;
		rtext <= 'b00101000;
	  end
	  st_st12_n: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b11100110;
	  end
	  st_st13: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b01110110;
	  end
	  st_st14: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14_n;
		rtext <= 'b01110110;
	  end
	  st_st14_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b01110011;
	  end
	  st_st15: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b01000101;
	  end
	  st_st16: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b01000101;
	  end
	  st_st16_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b00111001;
	  end
	  st_st17: begin
		if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17_n;
		rtext <= 'b00111001;
	  end
	  st_st17_n: begin
		if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b01111001;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st19;
		rtext <= 'b11001101;
	  end
	  st_st19: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st19_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b11001101;
	  end
	  st_st19_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b01010101;
	  end
	  st_st20: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st20_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st20_n;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st20_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st20_n;
		rtext <= 'b01010101;
	  end
	  st_st20_n: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st20;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b00010100;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st21_n;
		rtext <= 'b00010100;
	  end
	  st_st21_n: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b10010001;
	  end
	  st_st22: begin
		if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st23;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b11000000;
	  end
	  st_st23: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st23_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23_n;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23_n;
		rtext <= 'b11000000;
	  end
	  st_st23_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b00110011;
	  end
	  st_st24: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b00110011;
	  end
	  st_st24_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b00101111;
	  end
	  st_st25: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st19;
		else if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		rtext <= 'b11010000;
	  end
	  st_st26: begin
		if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[5] == 0 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st26_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st26_n;
		rtext <= 'b11010000;
	  end
	  st_st26_n: begin
		if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[5] == 0 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st26;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b01011001;
	  end
	  st_st27: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b10001011;
	  end
	  st_st28: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st19;
		rtext <= 'b11000001;
	  end
	  st_st29: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29_n;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st29_n;
		rtext <= 'b11000001;
	  end
	  st_st29_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st29;
		rtext <= 'b01001101;
	  end
	  st_st30: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st31;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st31;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b01010001;
	  end
	  st_st31: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st31_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st31_n;
		rtext <= 'b01010001;
	  end
	  st_st31_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b01000001;
	  end
	  st_st32: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b11110010;
	  end
	  st_st33: begin
		if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b01011111;
	  end
	  st_st34: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st35;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st34_n;
		rtext <= 'b01011111;
	  end
	  st_st34_n: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st35;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[5] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st34;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st34;
		rtext <= 'b11001001;
	  end
	  st_st35: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st36;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b11101000;
	  end
	  st_st36: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st36_n;
		rtext <= 'b11101000;
	  end
	  st_st36_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st36;
		rtext <= 'b11101000;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
