module fsm_rd_152_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [6:0] ptext;
	output[6:0] rtext;
	reg [6:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_152_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b1100001;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st2_n;
		rtext <= 'b1100001;
	  end
	  st_st2_n: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b0011110;
	  end
	  st_st3: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st20;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b1000011;
	  end
	  st_st4: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b1000011;
	  end
	  st_st4_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b1111101;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b1100001;
	  end
	  st_st6: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6_n;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6_n;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b1100001;
	  end
	  st_st6_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b1100000;
	  end
	  st_st7: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st7_n;
		rtext <= 'b1100000;
	  end
	  st_st7_n: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b0101101;
	  end
	  st_st8: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st7;
		else if(ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b1110000;
	  end
	  st_st9: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b1110000;
	  end
	  st_st9_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b1110110;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b1000000;
	  end
	  st_st11: begin
		if(1)
 		  NextState <= st_st12;
		rtext <= 'b1101010;
	  end
	  st_st12: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12_n;
		rtext <= 'b1101010;
	  end
	  st_st12_n: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b0100010;
	  end
	  st_st13: begin
		if(1)
 		  NextState <= st_st14;
		rtext <= 'b1110010;
	  end
	  st_st14: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14_n;
		rtext <= 'b1110010;
	  end
	  st_st14_n: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b0111111;
	  end
	  st_st15: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st15_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st15_n;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st15_n;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st15_n;
		rtext <= 'b0111111;
	  end
	  st_st15_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b0100000;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[5] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b0000010;
	  end
	  st_st17: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st17_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st17_n;
		rtext <= 'b0000010;
	  end
	  st_st17_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b1000011;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b1100011;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b1110000;
	  end
	  st_st20: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st20_n;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st20_n;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st20_n;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st20_n;
		rtext <= 'b1110000;
	  end
	  st_st20_n: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st20;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st20;
		rtext <= 'b1100100;
	  end
	  st_st21: begin
		if(1)
 		  NextState <= st_st22;
		rtext <= 'b1100110;
	  end
	  st_st22: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b1100110;
	  end
	  st_st22_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b1001010;
	  end
	  st_st23: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23_n;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23_n;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23_n;
		rtext <= 'b1001010;
	  end
	  st_st23_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		rtext <= 'b0101000;
	  end
	  st_st24: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b0100110;
	  end
	  st_st25: begin
		if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st25_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st25_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st25_n;
		else if(ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25_n;
		rtext <= 'b0100110;
	  end
	  st_st25_n: begin
		if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st25;
		else if(ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b1000000;
	  end
	  st_st26: begin
		if(1)
 		  NextState <= st_st3;
		rtext <= 'b1101010;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st28;
		rtext <= 'b0110011;
	  end
	  st_st28: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st28_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st28_n;
		rtext <= 'b0110011;
	  end
	  st_st28_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b1010001;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st30;
		rtext <= 'b1000111;
	  end
	  st_st30: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30_n;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st30_n;
		rtext <= 'b1000111;
	  end
	  st_st30_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st31;
		else if(ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st30;
		rtext <= 'b1000110;
	  end
	  st_st31: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st31_n;
		rtext <= 'b1000110;
	  end
	  st_st31_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b1101101;
	  end
	  st_st32: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b1101101;
	  end
	  st_st33: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st33_n;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st33_n;
		rtext <= 'b1101101;
	  end
	  st_st33_n: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st33;
		rtext <= 'b0100000;
	  end
	  st_st34: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b0100000;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
