module fsm_rd_083_s (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [10:0] ptext;
	output[10:0] rtext;
	reg [10:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_083_s_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st36;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b10110110001;
	  end
	  st_st1_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st36;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b11011000111;
	  end
	  st_st2: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st2_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st10;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b11011000111;
	  end
	  st_st2_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st10;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b11010110100;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b11010110101;
	  end
	  st_st4: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4_n;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4_n;
		else if(ptext[2] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		else if(ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st4_n;
		rtext <= 'b11010110101;
	  end
	  st_st4_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st4;
		else if(ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b01011110110;
	  end
	  st_st5: begin
		if(1)
 		  NextState <= st_st6;
		rtext <= 'b11011000100;
	  end
	  st_st6: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[9] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[1] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6_n;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6_n;
		rtext <= 'b11011000100;
	  end
	  st_st6_n: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[9] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b11100110011;
	  end
	  st_st7: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st7_n;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7_n;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st7_n;
		rtext <= 'b11100110011;
	  end
	  st_st7_n: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b11001101111;
	  end
	  st_st8: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8_n;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b11001101111;
	  end
	  st_st8_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st8;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[4] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b10001000001;
	  end
	  st_st9: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[8] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b10001000001;
	  end
	  st_st9_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[8] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b11001000000;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b10101100001;
	  end
	  st_st11: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11_n;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st20;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b10101100001;
	  end
	  st_st11_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st20;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b00010110100;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[8] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b00010110100;
	  end
	  st_st12_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[8] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st37;
		else if(ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b01000101001;
	  end
	  st_st13: begin
		if(1)
 		  NextState <= st_st14;
		rtext <= 'b00100110000;
	  end
	  st_st14: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14_n;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14_n;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st14_n;
		rtext <= 'b00100110000;
	  end
	  st_st14_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b01001010110;
	  end
	  st_st15: begin
		if(1)
 		  NextState <= st_st16;
		rtext <= 'b11011001000;
	  end
	  st_st16: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16_n;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16_n;
		rtext <= 'b11011001000;
	  end
	  st_st16_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b00000101100;
	  end
	  st_st17: begin
		if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st17_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st17_n;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st17_n;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st17_n;
		rtext <= 'b00000101100;
	  end
	  st_st17_n: begin
		if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[10] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st17;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b00110000101;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st19;
		rtext <= 'b11001110011;
	  end
	  st_st19: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19_n;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19_n;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19_n;
		else if(ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19_n;
		rtext <= 'b11001110011;
	  end
	  st_st19_n: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[10] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st19;
		else if(ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st19;
		rtext <= 'b00001100001;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b11100101101;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21_n;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b11100101101;
	  end
	  st_st21_n: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b11111000000;
	  end
	  st_st22: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st22_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b11111000000;
	  end
	  st_st22_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b10010000000;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'b10011001100;
	  end
	  st_st24: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		else if(ptext[3] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24_n;
		rtext <= 'b10011001100;
	  end
	  st_st24_n: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[10] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b11000100110;
	  end
	  st_st25: begin
		if(1)
 		  NextState <= st_st26;
		rtext <= 'b11111110110;
	  end
	  st_st26: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[1] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		else if(ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26_n;
		rtext <= 'b11111110110;
	  end
	  st_st26_n: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		else if(ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b10011000110;
	  end
	  st_st27: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27_n;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st27_n;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st27_n;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27_n;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st27_n;
		rtext <= 'b10011000110;
	  end
	  st_st27_n: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[5] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st27;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st27;
		rtext <= 'b10011000001;
	  end
	  st_st28: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28_n;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[8] == 1 )
 		  NextState <= st_st29;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st28_n;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st28_n;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28_n;
		rtext <= 'b10011000001;
	  end
	  st_st28_n: begin
		if(ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[8] == 1 )
 		  NextState <= st_st29;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st29;
		else if(ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st28;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st28;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b11100010110;
	  end
	  st_st29: begin
		if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[3] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29_n;
		else if(ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29_n;
		rtext <= 'b11100010110;
	  end
	  st_st29_n: begin
		if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st21;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[3] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st29;
		else if(ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b11111101100;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b10010111000;
	  end
	  st_st31: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[0] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[1] == 1  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st31_n;
		else if(ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st31_n;
		rtext <= 'b10010111000;
	  end
	  st_st31_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st31;
		else if(ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b10001010100;
	  end
	  st_st32: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st31;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32_n;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32_n;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32_n;
		else if(ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32_n;
		else if(ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32_n;
		else if(ptext[1] == 0  && ptext[9] == 1 )
 		  NextState <= st_st32_n;
		rtext <= 'b10001010100;
	  end
	  st_st32_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st31;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st31;
		else if(ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st32;
		else if(ptext[4] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[9] == 1 )
 		  NextState <= st_st32;
		rtext <= 'b01010001001;
	  end
	  st_st33: begin
		if(1)
 		  NextState <= st_st34;
		rtext <= 'b11000000010;
	  end
	  st_st34: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st33;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[3] == 1  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34_n;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34_n;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34_n;
		else if(ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st34_n;
		rtext <= 'b11000000010;
	  end
	  st_st34_n: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st33;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[3] == 1  && ptext[10] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[10] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st34;
		else if(ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b10110100011;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st36;
		rtext <= 'b01011100111;
	  end
	  st_st36: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st38;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st40;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st36_n;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st36_n;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st38;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st38;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st40;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st40;
		else if(ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st42;
		else if(ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b01011100111;
	  end
	  st_st36_n: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st38;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st40;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st36;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st38;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st38;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st40;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st40;
		else if(ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st42;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st42;
		else if(ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b10001100111;
	  end
	  st_st37: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37_n;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37_n;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37_n;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37_n;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37_n;
		else if(ptext[3] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37_n;
		rtext <= 'b10001100111;
	  end
	  st_st37_n: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[3] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b10001101011;
	  end
	  st_st38: begin
		if(1)
 		  NextState <= st_st39;
		rtext <= 'b00101000010;
	  end
	  st_st39: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st38;
		else if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st39_n;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st39_n;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st39_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st39_n;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st39_n;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st39_n;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39_n;
		rtext <= 'b00101000010;
	  end
	  st_st39_n: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st38;
		else if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st39;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st39;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 0 )
 		  NextState <= st_st39;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st39;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		rtext <= 'b00101010001;
	  end
	  st_st40: begin
		if(1)
 		  NextState <= st_st41;
		rtext <= 'b11011011110;
	  end
	  st_st41: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st41_n;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st22;
		else if(ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st41_n;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st41_n;
		else if(ptext[0] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st41_n;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 1 )
 		  NextState <= st_st41_n;
		else if(ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st41_n;
		rtext <= 'b11011011110;
	  end
	  st_st41_n: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st22;
		else if(ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[7] == 1 )
 		  NextState <= st_st41;
		else if(ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st41;
		rtext <= 'b10111110000;
	  end
	  st_st42: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42_n;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st22;
		else if(ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42_n;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42_n;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42_n;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42_n;
		else if(ptext[2] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42_n;
		rtext <= 'b10111110000;
	  end
	  st_st42_n: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st22;
		else if(ptext[10] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42;
		else if(ptext[2] == 1  && ptext[10] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b10111110000;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
